// uart output

// dont forget to add pico_multicore in the target_link_libraries
// target_link_libraries(... pico_stdlib pico_multicore)
// CMakeLists.txt
// https://learnembeddedsystems.co.uk/basic-multicore-pico-example

#include "pico/stdlib.h"
#include "pico/multicore.h"
#include <stdio.h>
#include <math.h>

#include "pico/time.h"
#include "hardware/irq.h"
#include "hardware/structs/adc.h"
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_pwm\include\hardware\pwm.h>
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_adc\include\hardware\adc.h>
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_gpio\include\hardware\gpio.h>

#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_sync\include\hardware\sync.h>

#include "hardware/resets.h"
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_spi\include\hardware\spi.h>
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_spi\spi.c>


#define PWM_PIN1 2    // pin 4
//#define PWM_PIN2 3    // pin 5
#define GPIO4 4     // pin 6    

#define cpuClkKhz 125000
//float xxsampleFrequency ;

int LOsinTab[4096] ;
int LOcosTab[4096] ;
float cosTab[4096] ;
float sinTab[4096] ;

uint32_t DDSp ; // DDS phase value
uint32_t DDSdDAC ; // DDS phase delta
uint32_t DDSdADC ; // DDS phase delta

double fSampleDAC ;
double fSampleADC ;

#define nSHDN 1 
#define nGA   1 

//-----------------------------------------------------------------------------------

static void approxSleepUs(int n){
  for(int k=0 ; k<n ; k++){
    for( int kk=0 ; kk<5 ; kk++){
      asm volatile("nop");
      }
    }
  }
  
static void approxSleepMs(int n){
  for(int k=0 ; k<n ; k++){
    for( int kk=0 ; kk<10 ; kk++){
      approxSleepUs(1000) ;
      }
    }
  }

static volatile void approxSleepUsTest(){
  printf("atleastSleepUsTest()\n") ;
  save_and_disable_interrupts() ;
  while(1){
    sio_hw->gpio_set =(1ul << GPIO4) ;  
	  approxSleepUs(1000) ;
    //sleep_ms(1) ;
    sio_hw->gpio_clr =(1ul << GPIO4) ;  
    approxSleepUs(1000) ;
  //  printf(".") ;
  }
} 

#include "graph1.c"
#include "core2.c"

//------------------------------------------------------------------------------------------------------

uint16_t spiBuf16[2];

void on_pwm_wrap() {
 // gpio_put(GPIO4, 1);
  DDSp += DDSdDAC ; 
  spiBuf16[0] = LOcosTab[DDSp>>20] | (nSHDN<<12) | (nGA<<13) ;
  // Clear the interrupt flag that brought us here
  pwm_clear_irq(pwm_gpio_to_slice_num(PWM_PIN1));
  spi_write16_blocking(spi_default, spiBuf16, 1);
 // gpio_put(GPIO4, 0);
  }


float resultGain ;
float resultPhase ;

//-----------------------------------------------------------------------------------

int np=0 ;

#define npMax 1000 
float iiFrq[npMax] ;
float iiGain[npMax] ;
float iiPhase[npMax] ;

float sqr(float x){ return x*x ; }

#define debug 0

float lastFrq=1e6 ;
float lastGain=0 ;
float lastPhase=0 ;

int xxLast=0 ;
int yyLast=0 ;

void oneMeasurement(float frq){
  DDSdDAC=(int)( 4294967296.0*frq/fSampleDAC) ;
  DDSdADC=(int)( 4294967296.0*frq/fSampleADC) ;
  printf("f: %6d;",(int)frq) ;

  float Tperiod=1.0/frq ;
  int nPeriod=Tperiod*fSampleADC ;
  int nPeriods=(ADCbufSize-100)/nPeriod ;
  int samplesUsed=nPeriod*nPeriods ;

  printf(" np=%6d samplesUsed=%6d ",nPeriod,samplesUsed) ;
  ADCbufPtr=0 ;
  while(ADCbufPtr!=ADCbufSize){} ;
  float Isum1=0 ;
  float Qsum1=0 ;
  float Isum2=0 ;
  float Qsum2=0 ;
 
  uint32_t DDSphase=0 ;


  for(int k=50 ; k<samplesUsed+50 ; k++){  
    DDSphase += DDSdADC ;
    float cos=cosTab[DDSphase>>20] ;
    float sin=sinTab[DDSphase>>20] ;
    float adc1=ADCbuf1[k]-2048 ;
    float adc2=ADCbuf2[k]-2048 ;

    Isum1 += cos*adc1 ;
    Qsum1 += sin*adc1 ;
    Isum2 += cos*adc2 ;
    Qsum2 += sin*adc2 ;
    }
  float ampl1=sqrt(sqr(Isum1)+sqr(Qsum1)) ;
  float phi1=atan2(Isum1,Qsum1)  ;
  float ampl2=sqrt(sqr(Isum2)+sqr(Qsum2)) ;
  float phi2=atan2(Isum2,Qsum2)  ;
  float phase=phi1-phi2 ;
  float gain=ampl2/ampl1 ;

  float tau=2.5e-6 ; // ADC time difference
  float phiCorr=2*M_PI*tau*frq ;
  phase += phiCorr ;

  if(phase<-M_PI){ phase+= 2*M_PI ; }
  if(phase> M_PI){ phase-= 2*M_PI ; }
  float phaseDegree=180.0*phase/M_PI ;

  

  resultGain=gain ;
  resultPhase=phase ;
  if(gainPhasePlot){
    printf(" g:%10.5f; p:%10.5f;\n",gain,phaseDegree) ;
    printf("M%d;%d;\n",xOfF(frq),yOfG(gain)) ;
    printf("C5;\n") ;
    printf("M%d;%d;\n",xOfF(frq),yOfP(phaseDegree)) ;
    printf("C5;\n") ;
    if(frq>lastFrq){
      printf("L%d;%d;%d;%d;\n",xOfF(lastFrq),yOfG(lastGain),xOfF(frq),yOfG(gain)) ;
      printf("L%d;%d;%d;%d;\n",xOfF(lastFrq),yOfP(lastPhase),xOfF(frq),yOfP(phaseDegree)) ;
      }
    }  
  

  if(vectorPlot){
    float rr=300 ;
    int xx=IQxx(gain*cos(phase)) ;
    int yy=IQyy(gain*sin(phase)) ;
    if(frq>lastFrq){
      printf("L%d;%d;%d;%d;\n",xxLast,yyLast,xx,yy) ;
      }
    xxLast=xx ;
    yyLast=yy ;
    }

  lastFrq=frq ;
  lastGain=gain ;
  lastPhase=phaseDegree ;

  if(debug){
  printf("B\n") ; sleep_ms(100) ;
  printf("M10;50;\n") ;
  printf("T%cgain %10.5f phase=%10.5f %c\n",'"',gain,phase,'"') ;
  
  int nx=150 ;
  printf("S 0;255;255;\n") ;
  int first=1 ;
  int xx,yy ;
  for(int k=50 ; k<nx ; k++){
    xx=2*k-50 ; yy=400-ADCbuf1[k]/10 ;
    if(first){ printf("M%d;%d;\n",xx,yy) ; first=0 ; }
     else{ printf("D%d;%d;\n",xx,yy) ; first=0 ; }
    }
  printf("S 255;255;0;\n") ;
  first=1 ;
  for(int k=50 ; k<nx ; k++){
    xx=2*k-50+500 ; yy=400-ADCbuf2[k]/10 ;
    if(first){ printf("M%d;%d;\n",xx,yy) ; first=0 ; }
     else{ printf("D%d;%d;\n",xx,yy) ; first=0 ; }
    }
  }}


void sweep(){
  if(debug){ oneMeasurement(2000) ; return ; }
 
  printf("B\n") ; sleep_ms(100) ;
  grFrame() ;
  printf("M10;50;\n") ;
  printf("T%cVNA 3.0%c\n",'"','"') ;
  SStroke(255,255,0) ;

  float frq=fMin ;
  np=0 ;
  while(frq<=fMax ){
    oneMeasurement(frq) ;
    if(np<npMax){
      iiFrq[np]=frq ;
      iiGain[np]=resultGain ;
      iiPhase[np]=resultPhase ;
      np++ ;
      }
    frq *= 1.05 ;
    }
  if(gainPhasePlot){
    printf("S 0;255;255;\n") ;
    for(int k=0 ; k<np ; k++){
      int xx=xOfF(iiFrq[k]) ;
      int yy=yOfG(iiGain[k]) ;
      if(k==0){ printf("M%d;%d;\n",xx,yy) ; }
       else{ printf("D%d;%d;\n",xx,yy) ; }
      }
    printf("S 255;255;0;\n") ;
    for(int k=0 ; k<np ; k++){  
      int xx=xOfF(iiFrq[k]) ;
      int yy=yOfP(iiPhase[k]) ;
      if(k==0){ printf("M%d;%d;\n",xx,yy) ; }
       else{ printf("D%d;%d;\n",xx,yy) ; }
      }
    }
   PPrint() ; 
   sleep_ms(10000) ;  
  }  
//-----------------------------------------------------------------------------------

void adc_init(void) {
    // ADC is in an unknown state. We should start by resetting it
    reset_block(RESETS_RESET_ADC_BITS);
    unreset_block_wait(RESETS_RESET_ADC_BITS);

    // Now turn it back on. Staging of clock etc is handled internally
    adc_hw->cs = ADC_CS_EN_BITS;

    // Internal staging completes in a few cycles, but poll to be sure
    while (!(adc_hw->cs & ADC_CS_READY_BITS)) {
        tight_loop_contents();
    }
}




void PWMsetup(){    
  gpio_set_function(PWM_PIN1, GPIO_FUNC_PWM);
//  gpio_set_function(PWM_PIN2, GPIO_FUNC_PWM);
   // Figure out which slice we just connected to the pin
  uint slice_num1 = pwm_gpio_to_slice_num(PWM_PIN1);
//  uint slice_num2 = pwm_gpio_to_slice_num(PWM_PIN2);
  // Mask our slice's IRQ output into the PWM block's single interrupt line,
  // and register our interrupt handler

  if(1){
    pwm_clear_irq(slice_num1);
    pwm_set_irq_enabled(slice_num1, true);
    irq_set_exclusive_handler(PWM_IRQ_WRAP, on_pwm_wrap);
    irq_set_enabled(PWM_IRQ_WRAP, true);
    }
  // Get some sensible defaults for the slice configuration. 
  pwm_config config1 = pwm_get_default_config();
  // Set divider, reduces counter clock to sysclock/this value
  pwm_config_set_clkdiv(&config1, 1.f);
  pwm_config_set_output_polarity (&config1,1,0) ; // invert A channel

  // Load the configuration into our PWM slice, and set it running.
  pwm_init(slice_num1, &config1, true);
  // Set period of 125 cycles (0 to 124 inclusive)
  //pwm_set_wrap(slice_num1,124 );
  #define clkDiv 625
  pwm_set_wrap(slice_num1,(clkDiv-1) );
  fSampleDAC=125e6/clkDiv/1.0 ;
  printf("fSampleDAC=%15.5f\n",fSampleDAC) ;
  printf("PWM_PIN1=%d\n",PWM_PIN1) ;
  printf("slice_num1=%d\n",slice_num1) ;
  
//  printf("PWM_PIN2=%d\n",PWM_PIN2) ;
//  printf("slice_num2=%d\n",slice_num2) ;

  printf("config1=%d\n",config1) ;

  pwm_set_gpio_level(PWM_PIN1, 500);
 // pwm_set_gpio_level(PWM_PIN2, 400);

  printf("\n") ;
  }

void ADCshow(){
   while(1){
    adc_select_input(2);
    approxSleepUs(100) ;
    result2 = adc_read()-2048;
    adc_select_input(1);
    approxSleepUs(100) ;
    result1 = adc_read()-2048;
    printf("ADC1-2048=%8d  ADC2-2048=%8d\n",result1,result2) ;
    sleep_ms(500) ;
    }
  }

int kDown ;

void abort(){
  printf("abort..\n") ;
  printf("\n") ;
  while(1){} ;
  }

const float conversion_factor = 3.3f / (1 << 12);

int main() {
  stdio_init_all();

  gpio_init(GPIO4);
  gpio_set_dir(GPIO4, GPIO_OUT);
 
 approxSleepMs(200);
  printf("//\n") ;
  printf("//\n") ;
  printf("Hello MCP4821viaSPIandFIFOandIRQandPWMserialViaHWrs232v01.c !\n") ;

  
  spi_init(spi_default,  8000000);
  // gpio_set_function(PICO_DEFAULT_SPI_RX_PIN, GPIO_FUNC_SPI);
  gpio_set_function(PICO_DEFAULT_SPI_SCK_PIN, GPIO_FUNC_SPI);
  gpio_set_function(PICO_DEFAULT_SPI_TX_PIN, GPIO_FUNC_SPI);
  spi_set_format(spi_default,16,0,0,SPI_MSB_FIRST) ;

   printf("Hello 2\n") ;

  
   adc_init() ;
   //ADCshow() ;

  // Make sure GPIO is high-impedance, no pullups etc
  adc_gpio_init(27);
  adc_gpio_init(28);

   adc_select_input(2) ;
 
   printf("Hello 3\n") ;
/*
  while (1) {
        adc_select_input(1);
        gpio_put(GPIO4, 1);
        result1 = adc_read();
        printf("Hello 4\n") ;
         gpio_put(GPIO4, 0);
        adc_select_input(2);
        result2 = adc_read();
        printf("Hello 5\n") ;
        printf("Raw value1: 0x%03x, voltage: %f V   ", result1, result1 * conversion_factor);
        printf("Raw value2: 0x%03x, voltage: %f V\n", result2, result2 * conversion_factor);
        sleep_ms(500);
    }
*/
   PWMsetup() ;
   multicore_launch_core1(core1_entry);

 for(int k=0 ; k<4096 ; k++){
    double phi=2*M_PI*k/4096.0 ;
    LOcosTab[k]=2048+1800*cos(phi) ;
    LOsinTab[k]=2048+1800*sin(phi) ;
    cosTab[k]=cos(phi) ;
    sinTab[k]=sin(phi) ;
    }

/*
float DDSfrq=1e3 ;
DDSdDAC=(int)( 4294967296.0*DDSfrq/fSampleDAC) ;
while(1){
  gpio_put(GPIO5, 1);
  asm volatile("nop"); asm volatile("nop"); asm volatile("nop");
  gpio_put(GPIO5, 0);
  asm volatile("nop"); asm volatile("nop"); asm volatile("nop");
  }
*/

  while(1){
    sweep() ;
    }

 }  

